diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-mac.cc ns-3.31/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-mac.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -595,14 +1106,38 @@
             }
 
           if (acceptFrame
-              && (receivedMacHdr.GetDstAddrMode () == 2))
+              && (receivedMacHdr.GetDstAddrMode () == SHORT_ADDR))
             {
-              acceptFrame = receivedMacHdr.GetShortDstAddr () == m_shortAddress
-                || receivedMacHdr.GetShortDstAddr () == Mac16Address ("ff:ff");        // check for broadcast addrs
+              if (receivedMacHdr.GetShortDstAddr () == m_shortAddress)
+                {
+                  // unicast, for me
+                  acceptFrame = true;
+                }
+              else if (receivedMacHdr.GetShortDstAddr () == Mac16Address ("ff:ff"))
+                {
+                  // broadcast
+                  acceptFrame = true;
+                }
+              else
+                {
+                  // multicast
+                  // See RFC 4944, Section 12
+                  // Multicast address 16 bits: 100X XXXX XXXX XXXX
+                  uint8_t buf[2];
+                  receivedMacHdr.GetShortDstAddr ().CopyTo (buf);
+                  if (buf[0] & 0x80)
+                    {
+                      acceptFrame = true;
+                    }
+                  else
+                    {
+                      acceptFrame = false;
+                    }
+                }
             }
 
           if (acceptFrame
-              && (receivedMacHdr.GetDstAddrMode () == 3))
+              && (receivedMacHdr.GetDstAddrMode () == EXT_ADDR))
             {
               acceptFrame = (receivedMacHdr.GetExtDstAddr () == m_selfExt);
             }
@@ -626,7 +1161,7 @@
                   || (receivedMacHdr.GetType () == LrWpanMacHeader::LRWPAN_MAC_COMMAND))
               && (receivedMacHdr.GetSrcAddrMode () > 1))
             {
-              acceptFrame = receivedMacHdr.GetSrcPanId () == m_macPanId; // \todo need to check if PAN coord
+              acceptFrame = receivedMacHdr.GetSrcPanId () == m_macPanId; // TODO: need to check if PAN coord
             }
 
           if (acceptFrame)
@@ -660,18 +1195,145 @@
                   // Cancel any pending MAC state change, ACKs have higher priority.
                   m_setMacState.Cancel ();
                   ChangeMacState (MAC_IDLE);
+
                   m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SendAck, this, receivedMacHdr.GetSeqNum ());
                 }
 
-              if (receivedMacHdr.IsData () && !m_mcpsDataIndicationCallback.IsNull ())
+
+              if (receivedMacHdr.GetDstAddrMode () == SHORT_ADDR)
+                {
+                  NS_LOG_DEBUG ("Packet from " << params.m_srcAddr);
+                  NS_LOG_DEBUG ("Packet to " << params.m_dstAddr);
+                }
+              else if (receivedMacHdr.GetDstAddrMode () == EXT_ADDR)
+                {
+                  NS_LOG_DEBUG ("Packet from " << params.m_srcExtAddr);
+                  NS_LOG_DEBUG ("Packet to " << params.m_dstExtAddr);
+                }
+
+
+              if (receivedMacHdr.IsBeacon ())
+                {
+
+
+                  // The received beacon size in symbols
+                  // Beacon = 5 bytes Sync Header (SHR) +  1 byte PHY header (PHR) + PSDU (default 17 bytes)
+                  m_rxBeaconSymbols = m_phy->GetPhySHRDuration () + 1 * m_phy->GetPhySymbolsPerOctet () +
+                    (originalPkt->GetSize () * m_phy->GetPhySymbolsPerOctet ());
+
+                  // The start of Rx beacon time and start of the Incoming superframe Active Period
+                  m_macBeaconRxTime = Simulator::Now () - Seconds (double(m_rxBeaconSymbols) / symbolRate);
+
+                  NS_LOG_DEBUG ("Beacon Received; forwarding up (m_macBeaconRxTime: " << m_macBeaconRxTime.As (Time::S) << ")");
+
+
+                  //TODO: Handle mlme-scan.request here
+
+                  // Device not associated.
+                  if (m_macPanId == 0xffff)
+                    {
+                      //TODO: mlme-associate.request here.
+                      NS_LOG_ERROR (this << "The current device is not associated to any coordinator");
+                      return;
+                    }
+
+
+                  if (m_macPanId != receivedMacHdr.GetDstPanId ())
+                    {
+                      return;
+                    }
+
+                  BeaconPayloadHeader receivedMacPayload;
+                  p->RemoveHeader (receivedMacPayload);
+
+                  SuperframeField incomingSuperframe;
+                  incomingSuperframe = receivedMacPayload.GetSuperframeSpecField ();
+
+                  m_incomingBeaconOrder = incomingSuperframe.GetBeaconOrder ();
+                  m_incomingSuperframeOrder = incomingSuperframe.GetFrameOrder ();
+                  m_incomingFnlCapSlot = incomingSuperframe.GetFinalCapSlot ();
+
+                  m_incomingBeaconInterval = ((uint32_t) 1 << m_incomingBeaconOrder) * aBaseSuperframeDuration;
+                  m_incomingSuperframeDuration = aBaseSuperframeDuration * ((uint32_t) 1 << m_incomingSuperframeOrder);
+
+                  if (incomingSuperframe.IsBattLifeExt ())
+                    {
+                      m_csmaCa->SetBatteryLifeExtension (true);
+                    }
+                  else
+                    {
+                      m_csmaCa->SetBatteryLifeExtension (false);
+                    }
+
+                  if (m_incomingBeaconOrder  < 15  && !m_csmaCa->IsSlottedCsmaCa ())
+                    {
+                      m_csmaCa->SetSlottedCsmaCa ();
+                    }
+
+                  //TODO: get Incoming frame GTS Fields here
+
+                  NS_LOG_DEBUG ("Incoming superframe Active Portion (Beacon + CAP + CFP): " << m_incomingSuperframeDuration << " symbols");
+
+                  //Begin CAP on the current device using info from the Incoming superframe
+                  m_incCapEvent =  Simulator::ScheduleNow (&LrWpanMac::StartCAP, this,SuperframeType::INCOMING);
+
+
+                  // Send a Beacon notification only if we are not
+                  // automatically sending data command requests or the beacon contains
+                  // a beacon payload in its MAC payload.
+                  // see IEEE 802.15.4-2011 Section 6.2.4.1
+                  if ((m_macAutoRequest == false) || p->GetSize () > 0)
+                    {
+                      //TODO: Add the rest of the MlmeBeaconNotifyIndication params
+                      if (!m_mlmeBeaconNotifyIndicationCallback.IsNull ())
+                        {
+                          MlmeBeaconNotifyIndicationParams beaconParams;
+                          beaconParams.m_bsn = receivedMacHdr.GetSeqNum ();
+                          m_mlmeBeaconNotifyIndicationCallback (beaconParams,originalPkt);
+                        }
+                    }
+
+                  if (m_macAutoRequest)
+                    {
+                      // check if MLME-SYNC.request was previously issued and running
+                      //  Sync. is necessary to handle pending messages (indirect transmissions)
+                      if (m_trackingEvent.IsRunning ())
+                        {
+                          m_trackingEvent.Cancel ();
+                          m_numLostBeacons = 0;
+
+                          if (m_beaconTrackingOn)
+                            {
+                              //if tracking option is on keep tracking the next beacon
+                              uint64_t searchSymbols;
+                              Time searchBeaconTime;
+
+                              searchSymbols = ((uint64_t) 1 << m_incomingBeaconOrder) + 1 * aBaseSuperframeDuration;
+                              searchBeaconTime = Seconds ((double) searchSymbols / symbolRate);
+                              m_trackingEvent = Simulator::Schedule (searchBeaconTime, &LrWpanMac::BeaconSearchTimeout, this);
+                            }
+
+                          PendingAddrFields pndAddrFields;
+                          pndAddrFields = receivedMacPayload.GetPndAddrFields ();
+
+                          //TODO: Ignore pending request if the address is in the GTS list.
+                          //      If the address is not in the GTS list, then  check if the address
+                          //      is in the short address pending list or in the extended address
+                          //      pending list.
+
+                        }
+                    }
+                }
+              else if (receivedMacHdr.IsData () && !m_mcpsDataIndicationCallback.IsNull ())
                 {
                   // If it is a data frame, push it up the stack.
-                  NS_LOG_DEBUG ("PdDataIndication():  Packet is for me; forwarding up");
+                  NS_LOG_DEBUG ("Data Packet is for me; forwarding up");
                   m_mcpsDataIndicationCallback (params, p);
                 }
               else if (receivedMacHdr.IsAcknowledgment () && m_txPkt && m_lrWpanMacState == MAC_ACK_PENDING)
                 {
                   LrWpanMacHeader macHdr;
+                  Time ifsWaitTime = Seconds ((double) GetIfsSize () / symbolRate);
                   m_txPkt->PeekHeader (macHdr);
                   if (receivedMacHdr.GetSeqNum () == macHdr.GetSeqNum ())
                     {
@@ -688,8 +1350,9 @@
                           m_mcpsDataConfirmCallback (confirmParams);
                         }
                       RemoveFirstTxQElement ();
-                      m_setMacState.Cancel ();
-                      m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+
+                      // Ack was succesfully received, wait for the Interframe Space (IFS) and then proceed
+                      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this);
                     }
                   else
                     {
@@ -716,6 +1379,8 @@
     }
 }
 
+
+
 void
 LrWpanMac::SendAck (uint8_t seqno)
 {
@@ -743,6 +1408,7 @@
   // Switch transceiver to TX mode. Proceed sending the Ack on confirm.
   ChangeMacState (MAC_SENDING);
   m_phy->PlmeSetTRXStateRequest (IEEE_802_15_4_PHY_TX_ON);
+
 }
 
 void
@@ -787,6 +1453,15 @@
     }
 }
 
+void
+LrWpanMac::IfsWaitTimeout (void)
+{
+  NS_LOG_DEBUG ("IFS Completed");
+  m_setMacState.Cancel ();
+  m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+}
+
+
 bool
 LrWpanMac::PrepareRetransmission (void)
 {
@@ -821,22 +1496,49 @@
 LrWpanMac::PdDataConfirm (LrWpanPhyEnumeration status)
 {
   NS_ASSERT (m_lrWpanMacState == MAC_SENDING);
-
   NS_LOG_FUNCTION (this << status << m_txQueue.size ());
 
   LrWpanMacHeader macHdr;
+  Time ifsWaitTime;
+  uint64_t symbolRate;
+
+  symbolRate = (uint64_t) m_phy->GetDataOrSymbolRate (false); //symbols per second
+
   m_txPkt->PeekHeader (macHdr);
+
   if (status == IEEE_802_15_4_PHY_SUCCESS)
     {
       if (!macHdr.IsAcknowledgment ())
         {
-          // We have just send a regular data packet, check if we have to wait
-          // for an ACK.
-          if (macHdr.IsAckReq ())
+          if (macHdr.IsBeacon ())
+            {
+              ifsWaitTime = Seconds ((double) GetIfsSize () / symbolRate);
+
+              // The Tx Beacon in symbols
+              // Beacon = 5 bytes Sync Header (SHR) +  1 byte PHY header (PHR) + PSDU (default 17 bytes)
+              uint64_t beaconSymbols = m_phy->GetPhySHRDuration () + 1 * m_phy->GetPhySymbolsPerOctet () +
+                (m_txPkt->GetSize () * m_phy->GetPhySymbolsPerOctet ());
+
+              // The beacon Tx time and start of the Outgoing superframe Active Period
+              m_macBeaconTxTime = Simulator::Now () - Seconds (double(beaconSymbols) / symbolRate);
+
+
+              m_txPkt = 0;
+              m_capEvent = Simulator::ScheduleNow (&LrWpanMac::StartCAP, this, SuperframeType::OUTGOING);
+              NS_LOG_DEBUG ("Beacon Sent (m_macBeaconTxTime: " << m_macBeaconTxTime.As (Time::S) << ")");
+
+              MlmeStartConfirmParams  mlmeConfirmParams;
+              mlmeConfirmParams.m_status = MLMESTART_SUCCESS;
+              if (!m_mlmeStartConfirmCallback.IsNull ())
+                {
+                  m_mlmeStartConfirmCallback (mlmeConfirmParams);
+                }
+            }
+          else if (macHdr.IsAckReq ()) // We have sent a regular data packet, check if we have to wait  for an ACK.
             {
               // wait for the ack or the next retransmission timeout
               // start retransmission timer
-              Time waitTime = MicroSeconds (GetMacAckWaitDuration () * 1000 * 1000 / m_phy->GetDataOrSymbolRate (false));
+              Time waitTime = Seconds ((double) GetMacAckWaitDuration () / symbolRate);
               NS_ASSERT (m_ackWaitTimeout.IsExpired ());
               m_ackWaitTimeout = Simulator::Schedule (waitTime, &LrWpanMac::AckWaitTimeout, this);
               m_setMacState.Cancel ();
@@ -856,6 +1558,7 @@
                   confirmParams.m_status = IEEE_802_15_4_SUCCESS;
                   m_mcpsDataConfirmCallback (confirmParams);
                 }
+              ifsWaitTime = Seconds ((double) GetIfsSize () / symbolRate);
               RemoveFirstTxQElement ();
             }
         }
@@ -894,8 +1597,17 @@
       NS_FATAL_ERROR ("Transmission attempt failed with PHY status " << status);
     }
 
-  m_setMacState.Cancel ();
-  m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+
+  if (!ifsWaitTime.IsZero ())
+    {
+      m_ifsEvent = Simulator::Schedule (ifsWaitTime, &LrWpanMac::IfsWaitTimeout, this);
+    }
+  else
+    {
+      m_setMacState.Cancel ();
+      m_setMacState = Simulator::ScheduleNow (&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+    }
+
 }
 
 void
@@ -1021,9 +1733,14 @@
         }
       // remove the copy of the packet that was just sent
       RemoveFirstTxQElement ();
-
       ChangeMacState (MAC_IDLE);
     }
+  else if (m_lrWpanMacState == MAC_CSMA && macState == MAC_CSMA_DEFERRED)
+    {
+      ChangeMacState (MAC_IDLE);
+      m_txPkt = 0;
+      NS_LOG_DEBUG ("****** PACKET DEFERRED to the next superframe *****");
+    }
 }
 
 LrWpanAssociationStatus
@@ -1074,9 +1791,84 @@
 }
 
 void
+LrWpanMac::PrintTransmitQueueSize (void)
+{
+  NS_LOG_DEBUG("Transit Queue Size: "<<m_txQueue.size());
+}
+
+void
 LrWpanMac::SetMacMaxFrameRetries (uint8_t retries)
 {
   m_macMaxFrameRetries = retries;
 }
 
+bool
+LrWpanMac::isCoordDest (void)
+{
+  NS_ASSERT (m_txPkt);
+  LrWpanMacHeader macHdr;
+  m_txPkt->PeekHeader (macHdr);
+
+  if (m_macCoordShortAddress == macHdr.GetShortDstAddr ()
+      || m_macCoordExtendedAddress == macHdr.GetExtDstAddr ())
+    {
+      return true;
+    }
+  else
+    {
+      std::cout << "ERROR: Packet not for the coordinator!\n";
+      return false;
+
+    }
+
+}
+
+uint32_t
+LrWpanMac::GetIfsSize ()
+{
+  NS_ASSERT (m_txPkt);
+
+  if (m_txPkt->GetSize () <= aMaxSIFSFrameSize)
+    {
+      return m_macSIFSPeriod;
+    }
+  else
+    {
+      return m_macLIFSPeriod;
+    }
+}
+
+void
+LrWpanMac::SetAssociatedCoor (Mac16Address mac)
+{
+  m_macCoordShortAddress = mac;
+}
+
+void
+LrWpanMac::SetAssociatedCoor (Mac64Address mac)
+{
+  m_macCoordExtendedAddress = mac;
+}
+
+
+uint64_t
+LrWpanMac::GetTxPacketSymbols (void)
+{
+  NS_ASSERT (m_txPkt);
+  // Sync Header (SHR) +  8 bits PHY header (PHR) + PSDU
+  return (m_phy->GetPhySHRDuration () + 1 * m_phy->GetPhySymbolsPerOctet () +
+          (m_txPkt->GetSize () * m_phy->GetPhySymbolsPerOctet ()));
+}
+
+bool
+LrWpanMac::isTxAckReq (void)
+{
+  NS_ASSERT (m_txPkt);
+  LrWpanMacHeader macHdr;
+  m_txPkt->PeekHeader (macHdr);
+
+  return macHdr.IsAckReq ();
+}
+
 } // namespace ns3
+
